﻿@using LAP.DomainModels.Entities.Admin;
@model IEnumerable<ClientActivityLog>
@{
    string[] names = ViewBag.Names;
    var clientName = names[0];
    var spouseName = names[1];
    var fieldMapping = MenuDataHelper.GeFieldMappingDataAsync();
    string riskArcOwner = ((string)ViewBag.RiskArcOwner).Replace("{clientName}", clientName).Replace("{spouseName}", spouseName);
}
<div class="modal-dialog modal-lg" role="document">
    <div class="modal-content">
        <div class="modal-header">
            <h5 class="modal-title">
                @riskArcOwner @Model.FirstOrDefault().EntityModuleName
            </h5>
            <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                <i aria-hidden="true" class="ki ki-close"></i>
            </button>
        </div>
        <div class="modal-body">
            <ul>
                @foreach (var item in Model)
                {
                    var actionText = item.ActionType == ActionEnum.Insert.ToString() ? "added a new" :
                    item.ActionType == ActionEnum.Update.ToString() ? "updated the" : "deleted the";
                    var colorClass = (item.ActionType == ActionEnum.Insert.ToString() ? "success" : item.ActionType == ActionEnum.Update.ToString() ? "warning" : "danger");
                    <li class="mb-3" style="font-size: 1.1rem;">
                        @actionText
                        @item.EntityModuleName
                        <span class="text-primary">@Html.Raw(item.Title)</span>
                        @if (item.Changes != null)
                        {
                            <div class="alert alert-custom alert-notice alert-light-@colorClass mt-2" role="alert" style="width:fit-content">
                                <ul class="mb-0">
                                    @foreach (var item2 in item.Changes)
                                    {
                                        var fieldChange = (FieldChangeModel)item2.Value;
                                        var fieldMaps = fieldMapping.Where(m => m.FieldName == item2.Key);
                                        var fieldMap = fieldMaps.Count() > 1 ? fieldMaps.FirstOrDefault(m => m.TableName == item.EntityName) : fieldMaps.FirstOrDefault();
                                        var fieldTitle = fieldMap != null ? fieldMap.Title : item2.Key;
                                        fieldTitle = fieldTitle.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName);

                                        var oldValueFormatted = fieldTitle.Contains("Version") ? fieldChange.OldValueFormatted == "Yes" ? "InDepth" : "Express" : fieldChange.OldValueFormatted;
                                        var newValueFormatted = fieldTitle.Contains("Version") ? fieldChange.NewValueFormatted == "Yes" ? "InDepth" : "Express" : fieldChange.NewValueFormatted;

                                        oldValueFormatted = !string.IsNullOrEmpty(fieldChange.OldValueFormatted) && fieldChange.OldValueFormatted.Contains("{") ? fieldChange.OldValueFormatted.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName) : oldValueFormatted;
                                        newValueFormatted = !string.IsNullOrEmpty(fieldChange.NewValueFormatted) && fieldChange.NewValueFormatted.Contains("{") ? fieldChange.NewValueFormatted.Replace("{clientName}", clientName).Replace("{spouseName}", spouseName) : newValueFormatted;
                                        @if (item.ActionType == ActionEnum.Insert.ToString())
                                        {
                                            if (fieldChange.OldValue != null && fieldChange.NewValue != null && !string.IsNullOrEmpty(newValueFormatted) && !item2.Key.Contains("Id"))
                                            {
                                                <li class="font-weight-bolder">@fieldTitle: <span class="font-weight-normal">@Html.Raw(newValueFormatted)</span></li>
                                            }
                                        }
                                        else
                                        {
                                            <li>
                                                <span class="font-weight-bolder">@fieldTitle</span>
                                                <span class="font-weight-normal" style="text-underline-position: under">
                                                    @if (!string.IsNullOrEmpty(oldValueFormatted) && !string.IsNullOrEmpty(newValueFormatted))
                                                    {
                                                        <span>
                                                            updated from
                                                            <u>@Html.Raw(oldValueFormatted)</u>
                                                            to
                                                            <u>@Html.Raw(newValueFormatted)</u>
                                                        </span>
                                                    }
                                                    else
                                                    {
                                                        <span>
                                                            @(!string.IsNullOrEmpty(oldValueFormatted) ? "reset from" : "updated to")
                                                            <u>@(!string.IsNullOrEmpty(oldValueFormatted) ? Html.Raw(oldValueFormatted) : @Html.Raw(newValueFormatted))</u>
                                                        </span>
                                                    }
                                                </span>
                                            </li>
                                        }
                                    }
                                </ul>
                            </div>
                        }
                    </li>
                }
            </ul>
        </div>
    </div>
</div>